<?php

namespace FOS\HttpCacheBundle\Tests\Unit\Command;

use FOS\HttpCacheBundle\Command\InvalidateTagCommand;
use Symfony\Component\Console\Application;
use Symfony\Component\Console\Tester\CommandTester;

class InvalidateTagCommandTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @expectedException \RuntimeException
     */
    public function testExecuteMissingParameters()
    {
        $invalidator = \Mockery::mock('\FOS\HttpCacheBundle\CacheManager');

        $application = new Application();
        $application->add(new InvalidateTagCommand($invalidator));

        $command = $application->find('fos:httpcache:invalidate:tag');
        $commandTester = new CommandTester($command);
        $commandTester->execute(array('command' => $command->getName()));
    }

    public function testExecuteParameter()
    {
        $invalidator = \Mockery::mock('\FOS\HttpCacheBundle\CacheManager')
            ->shouldReceive('invalidateTags')->once()->with(array('my-tag'))
            ->getMock()
        ;

        $application = new Application();
        $application->add(new InvalidateTagCommand($invalidator));

        $command = $application->find('fos:httpcache:invalidate:tag');
        $commandTester = new CommandTester($command);
        $commandTester->execute(array(
            'command' => $command->getName(),
            'tags' => array('my-tag'),
        ));

        // the only output should be generated by the listener in verbose mode
        $this->assertEquals('', $commandTester->getDisplay());
    }
}
