<?php

namespace FOS\HttpCacheBundle\Tests\Unit\Command;

use FOS\HttpCacheBundle\Command\RefreshPathCommand;
use Symfony\Component\Console\Application;
use Symfony\Component\Console\Tester\CommandTester;

class RefreshPathCommandTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @expectedException \RuntimeException
     */
    public function testExecuteMissingParameters()
    {
        $invalidator = \Mockery::mock('\FOS\HttpCacheBundle\CacheManager');

        $application = new Application();
        $application->add(new RefreshPathCommand($invalidator));

        $command = $application->find('fos:httpcache:refresh:path');
        $commandTester = new CommandTester($command);
        $commandTester->execute(array('command' => $command->getName()));
    }

    public function testExecuteParameter()
    {
        $invalidator = \Mockery::mock('\FOS\HttpCacheBundle\CacheManager')
            ->shouldReceive('refreshPath')->once()->with('/my/path')
            ->shouldReceive('refreshPath')->once()->with('/other/path')
            ->getMock()
        ;

        $application = new Application();
        $application->add(new RefreshPathCommand($invalidator));

        $command = $application->find('fos:httpcache:refresh:path');
        $commandTester = new CommandTester($command);
        $commandTester->execute(array(
            'command' => $command->getName(),
            'paths' => array('/my/path', '/other/path'),
        ));

        // the only output should be generated by the listener in verbose mode
        $this->assertEquals('', $commandTester->getDisplay());
    }
}
